using Core.Interfaces;
using Domain.Entities;
using Models.Interfaces;

namespace Core.Services
{
    public class LookupService : ILookUpDom
    {
        #region Declaraciones y Constructor
        private readonly IPhSLookUpRepository _repository;
        public LookupService(IPhSLookUpRepository repository)
        {
            _repository = repository ?? throw new ArgumentNullException(nameof(repository));
        }
        #endregion
        #region Metodos de clases
        public Task<IEnumerable<ELookUpItem>> CustomersListAsync(string filter, int limit = 10) => _repository.CustomersListAsync(filter);
        public Task<IEnumerable<ELookUpItem>> InstitutionsListAsync(string filter, int limit = 10) => _repository.InstitutionsListAsync(filter);
        public Task<IEnumerable<ELookUpItem>> PatientsListAsync(string filter, int limit = 10) => _repository.PatientsListAsync(filter);
        public Task<IEnumerable<ELookUpItem>> ProfessionalsListAsync(string filter, int limit = 10) => _repository.ProfessionalsListAsync(filter);
        public Task<IEnumerable<ELookUpItem>> PeopleListAsync(string filter, int limit = 10) => _repository.PeopleListAsync(filter);
        public Task<IEnumerable<ELookUpItem>> BussinessUnitsListAsync(string filter, int limit = 10) => _repository.BussinessUnitsListAsync(filter);
        public Task<IEnumerable<EProductLookupItem>> ProductsListAsync(string filter, int limit = 10) =>
            _repository.ProductsListAsync(filter);
        public Task<IEnumerable<ELookUpItem>> PaymentTermsListAsync(string filter, int limit = 10)
            => _repository.PaymentTermsListAsync(filter, limit);
        public Task<IEnumerable<ELookUpItem>> ApprovedQuotesListAsync(string filter, int limit = 10) =>
            _repository.ApprovedQuotesListAsync(filter, limit);
        #endregion
    }
}
